> ## Documentation Index
> Fetch the complete documentation index at: https://cobo.com/developers/llms.txt
> Use this file to discover all available pages before exploring further.

# Estimate staking fees v2

> This operation calculates the fee required for a staking activity based on factors such as network congestion and transaction complexity.

<Note>For the Babylon protocol, you can only select UTXO as the fee model.</Note>


<Tip>
  Try [Cobo WaaS Skill](/v2/guides/overview/cobo-waas-skill) in your AI coding assistant (Claude Code, Cursor, etc.). Describe your needs in natural language to auto-generate production-ready SDK code and debug faster 🚀
</Tip>

<RequestExample>
  ```python Python theme={null}
  import cobo_waas2
  from cobo_waas2.models.eth_stake_estimated_fee import EthStakeEstimatedFee
  from cobo_waas2.models.get_staking_estimation_fee_request import (
      GetStakingEstimationFeeRequest,
  )
  from cobo_waas2.rest import ApiException
  from pprint import pprint

  # See configuration.py for a list of all supported configurations.
  configuration = cobo_waas2.Configuration(
      # Replace `<YOUR_PRIVATE_KEY>` with your private key
      api_private_key="<YOUR_PRIVATE_KEY>",
      # Select the development environment. To use the production environment, change the URL to https://api.cobo.com/v2.
      host="https://api.dev.cobo.com/v2",
  )
  # Enter a context with an instance of the API client
  with cobo_waas2.ApiClient(configuration) as api_client:
      # Create an instance of the API class
      api_instance = cobo_waas2.StakingsApi(api_client)
      get_staking_estimation_fee_request = cobo_waas2.GetStakingEstimationFeeRequest(
          activity_type="Stake",
          pool_id="babylon_btc_signet",
          amount="100.00",
          fee=cobo_waas2.TransactionRequestFee(
              cobo_waas2.TransactionRequestFixedFee(
                  fee_type="EVM_EIP_1559", token_id="TRON"
              )
          ),
      )

      try:
          # Estimate staking fees v2
          api_response = api_instance.get_staking_estimation_fee_v2(
              get_staking_estimation_fee_request=get_staking_estimation_fee_request
          )
          print("The response of StakingsApi->get_staking_estimation_fee_v2:\n")
          pprint(api_response)
      except Exception as e:
          print(
              "Exception when calling StakingsApi->get_staking_estimation_fee_v2: %s\n"
              % e
          )

  ```

  ```java Java theme={null}
  // Import classes:
  import com.cobo.waas2.ApiClient;
  import com.cobo.waas2.ApiException;
  import com.cobo.waas2.Configuration;
  import com.cobo.waas2.Env;
  import com.cobo.waas2.api.StakingsApi;
  import com.cobo.waas2.model.*;

  public class Example {
    public static void main(String[] args) {
      ApiClient defaultClient = Configuration.getDefaultApiClient();
      // Select the development environment. To use the production environment, replace `Env.DEV` with
      // `Env.PROD
      defaultClient.setEnv(Env.DEV);

      // Replace `<YOUR_PRIVATE_KEY>` with your private key
      defaultClient.setPrivKey("<YOUR_PRIVATE_KEY>");
      StakingsApi apiInstance = new StakingsApi();
      GetStakingEstimationFeeRequest getStakingEstimationFeeRequest =
          new GetStakingEstimationFeeRequest()
              .activityType(ActivityType.STAKE)
              .poolId(StakingPoolId.BABYLON_BTC_SIGNET)
              .amount("100.00")
              .fee(
                  new TransactionRequestFee(
                      new TransactionRequestFixedFee()
                          .feeType(FeeType.EVM_EIP_1559)
                          .tokenId("TRON")));
      try {
        EthStakeEstimatedFee result =
            apiInstance.getStakingEstimationFeeV2(getStakingEstimationFeeRequest);
        System.out.println(result);
      } catch (ApiException e) {
        System.err.println("Exception when calling StakingsApi#getStakingEstimationFeeV2");
        System.err.println("Status code: " + e.getCode());
        System.err.println("Reason: " + e.getResponseBody());
        System.err.println("Response headers: " + e.getResponseHeaders());
        e.printStackTrace();
      }
    }
  }

  ```

  ```go Go theme={null}
  package main

  import (
  	"context"
  	"fmt"
  	coboWaas2 "github.com/CoboGlobal/cobo-waas2-go-sdk/cobo_waas2"
  	"github.com/CoboGlobal/cobo-waas2-go-sdk/cobo_waas2/crypto"
  	"os"
  )

  func main() {
  	getStakingEstimationFeeRequest := coboWaas2.get_staking_estimation_fee_request{
  		EstimateClaimFee: coboWaas2.NewEstimateClaimFee(coboWaas2.ActivityType("Stake")),
  	}

  	configuration := coboWaas2.NewConfiguration()
  	// Initialize the API client
  	apiClient := coboWaas2.NewAPIClient(configuration)
  	ctx := context.Background()

  	// Select the development environment. To use the production environment, replace coboWaas2.DevEnv with coboWaas2.ProdEnv
  	ctx = context.WithValue(ctx, coboWaas2.ContextEnv, coboWaas2.DevEnv)
  	// Replace `<YOUR_PRIVATE_KEY>` with your private key
  	ctx = context.WithValue(ctx, coboWaas2.ContextPortalSigner, crypto.Ed25519Signer{
  		Secret: "<YOUR_PRIVATE_KEY>",
  	})
  	resp, r, err := apiClient.StakingsAPI.GetStakingEstimationFeeV2(ctx).
  		GetStakingEstimationFeeRequest(getStakingEstimationFeeRequest).
  		Execute()
  	if err != nil {
  		fmt.Fprintf(
  			os.Stderr,
  			"Error when calling `StakingsAPI.GetStakingEstimationFeeV2``: %v\n",
  			err,
  		)
  		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
  	}
  	// response from `GetStakingEstimationFeeV2`: EthStakeEstimatedFee
  	fmt.Fprintf(os.Stdout, "Response from `StakingsAPI.GetStakingEstimationFeeV2`: %v\n", resp)
  }

  ```

  ```javascript JavaScript theme={null}
  const CoboWaas2 = require("@cobo/cobo-waas2");
  // Initialize the API client
  const apiClient = CoboWaas2.ApiClient.instance;
  // Select the development environment. To use the production environment, replace `Env.DEV` with `Env.PROD`
  apiClient.setEnv(CoboWaas2.Env.DEV);
  // Replace `<YOUR_PRIVATE_KEY>` with your private key
  apiClient.setPrivateKey("<YOUR_PRIVATE_KEY>");
  // Call the API
  const apiInstance = new CoboWaas2.StakingsApi();
  const opts = {
    GetStakingEstimationFeeRequest:
      CoboWaas2.GetStakingEstimationFeeRequest.constructFromObject({
        activity_type: "Stake",
        pool_id: "babylon_btc_signet",
        amount: "100.00",
        fee: { fee_type: "EVM_EIP_1559", token_id: "TRON" },
      }),
  };
  apiInstance.getStakingEstimationFeeV2(opts).then(
    (data) => {
      console.log("API called successfully. Returned data: " + data);
    },
    (error) => {
      console.error(error);
    },
  );

  ```
</RequestExample>


## OpenAPI

````yaml post /stakings/estimate_fee_v2
openapi: 3.0.3
info:
  title: Cobo Wallet as a Service 2.0
  description: >
    The Cobo Wallet-as-a-Service (WaaS) 2.0 API is the latest version of Cobo's
    WaaS API offering. It enables you to access Cobo's full suite of crypto
    wallet technologies with powerful and flexible access controls. By
    encapsulating complex security protocols and streamlining blockchain
    interactions, this API allows you to concentrate on your core business
    activities without worrying about the safety of your assets. The WaaS 2.0
    API presents the following key features:


    - A unified API for Cobo's [all four wallet
    types](https://manuals.cobo.com/en/portal/introduction#an-all-in-one-wallet-platform)

    - Support for 80+ chains and 3000+ tokens

    - A comprehensive selection of webhook events

    - Flexible usage models for MPC Wallets, including [Organization-Controlled
    Wallets](https://manuals.cobo.com/en/portal/mpc-wallets/ocw/introduction)
    and [User-Controlled
    Wallets](https://manuals.cobo.com/en/portal/mpc-wallets/ucw/introduction)

    - Programmatic control of smart contract wallets such as Safe{Wallet} with
    fine-grained access controls

    - Seamlessly transfer funds across multiple exchanges, including Binance,
    OKX, Bybit, Deribit, and more


    For more information about the WaaS 2.0 API, see [Introduction to WaaS
    2.0](https://www.cobo.com/developers/v2/guides/overview/introduction).
  termsOfService: https://cobo.com/waas/tos/
  license:
    name: Apache 2.0
    url: https://www.apache.org/licenses/LICENSE-2.0.html
  contact:
    name: Cobo WaaS
    url: https://www.cobo.com/waas
    email: help@cobo.com
  version: 1.0.0
servers:
  - url: https://api.dev.cobo.com/v2
    description: Development environment
  - url: https://api.cobo.com/v2
    description: Production environment
security:
  - CoboAuth: []
tags:
  - name: Organizations
    description: Operations related to Organizations.
  - name: Wallets
    description: Operations related to all wallets.
  - name: Wallets - MPC Wallets
    description: Operations related to mpc wallet.
  - name: Wallets - Exchange Wallet
    description: Operations related to exchange wallet.
  - name: Wallets - Smart Contract Wallets
    description: Operations related to smart contract wallet.
  - name: Transactions
    description: Operations related to all transactions.
  - name: Developers - Webhooks
    description: Operations related to webhooks.
  - name: Stakings
    description: Operations related to staking.
  - name: OAuth
    description: Operations related to OAuth.
  - name: Developers
    description: Operations related to developers.
  - name: AddressBooks
    description: Operations related to address books.
  - name: TravelRule
    description: Operations related to travel rule.
  - name: GraphQL
    description: Operations related to executing GraphQL queries and mutations.
  - name: PrimeBroker
    description: Operations related to prime broker.
  - name: AppWorkflows
    description: Operations related to app workflow.
  - name: FeeStation
    description: Operations related to fee station.
  - name: Payment
    description: Operations related to payment.
  - name: Batch Payouts
    description: Operations related to batch payouts.
  - name: Tokenization
    description: Operations related to tokenization.
  - name: AutoSweep
    description: Operations related to auto sweep.
  - name: Compliance
    description: Operations related to compliance.
paths:
  /stakings/estimate_fee_v2:
    post:
      tags:
        - Stakings
      summary: Estimate staking fees v2
      description: >
        This operation calculates the fee required for a staking activity based
        on factors such as network congestion and transaction complexity.


        <Note>For the Babylon protocol, you can only select UTXO as the fee
        model.</Note>
      operationId: get_staking_estimation_fee_v2
      requestBody:
        $ref: '#/components/requestBodies/estimateStakeActivityFeeBody'
      responses:
        '201':
          $ref: '#/components/responses/estimateStakingFeeV2Response'
        4XX:
          $ref: '#/components/responses/badRequestError'
        5XX:
          $ref: '#/components/responses/internalServerError'
      security:
        - CoboAuth: []
        - OAuth2:
            - transaction.estimate_fee
components:
  requestBodies:
    estimateStakeActivityFeeBody:
      description: The request body to get the estimated fee of a staking activity.
      content:
        application/json:
          schema:
            oneOf:
              - $ref: '#/components/schemas/EstimateStakeFee'
              - $ref: '#/components/schemas/EstimateUnstakeFee'
              - $ref: '#/components/schemas/EstimateWithdrawFee'
              - $ref: '#/components/schemas/EstimateClaimFee'
            discriminator:
              propertyName: activity_type
              mapping:
                Stake:
                  $ref: '#/components/schemas/EstimateStakeFee'
                Unstake:
                  $ref: '#/components/schemas/EstimateUnstakeFee'
                Withdraw:
                  $ref: '#/components/schemas/EstimateWithdrawFee'
                Claim:
                  $ref: '#/components/schemas/EstimateClaimFee'
  responses:
    estimateStakingFeeV2Response:
      description: The request was successful.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/EthStakeEstimatedFee'
    badRequestError:
      description: >-
        Bad request. Your request contains malformed syntax or invalid
        parameters.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponse'
    internalServerError:
      description: Internal server error.
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/ErrorResponse'
  schemas:
    EstimateStakeFee:
      title: Staking fee
      allOf:
        - $ref: '#/components/schemas/BaseEstimateStakingFee'
        - $ref: '#/components/schemas/CreateStakeActivity'
    EstimateUnstakeFee:
      title: Unstaking fee
      allOf:
        - $ref: '#/components/schemas/BaseEstimateStakingFee'
        - $ref: '#/components/schemas/CreateUnstakeActivity'
    EstimateWithdrawFee:
      title: Withdrawal fee
      allOf:
        - $ref: '#/components/schemas/BaseEstimateStakingFee'
        - $ref: '#/components/schemas/CreateWithdrawActivity'
    EstimateClaimFee:
      title: Claim fee
      allOf:
        - $ref: '#/components/schemas/BaseEstimateStakingFee'
        - type: object
          properties:
            staking_id:
              type: string
              example: f47ac10b-58cc-4372-a567-0e02b2c3d479
              description: >-
                The ID of the staking position. You can retrieve a list of
                staking positions by calling [List staking
                positions](https://www.cobo.com/developers/v2/api-references/stakings/list-staking-positions).
            fee:
              $ref: '#/components/schemas/TransactionRequestFee'
    EthStakeEstimatedFee:
      title: Ethereum Staking Fee
      type: object
      properties:
        pool_type:
          $ref: '#/components/schemas/StakingPoolType'
        fee:
          $ref: '#/components/schemas/EstimatedFee'
        validator_pubkeys:
          type: array
          items:
            type: string
          description: >-
            A list of public keys associated with the Ethereum validators for
            this staking operation.
          example:
            - '0x1234567890987654321012345678909876543210'
        core_btc_staking_address:
          type: string
          description: >-
            The P2WSH address generated for this staking operation (only
            applicable if the estimated fee is for CORE staking).
          example: bc1qcqj9k34vrvgmmvt85ym2ua79k2d22vcfxmuratakfm78chdqksnq5agezk
    ErrorResponse:
      type: object
      description: The response of a failed request.
      required:
        - error_code
        - error_message
        - error_id
      properties:
        error_code:
          type: integer
          description: >-
            The error code. Refer to [Error codes and status
            codes](https://www.cobo.com/developers/v2/api-references/error-codes)
            for more details.
        error_message:
          type: string
          description: The error description.
        error_id:
          type: string
          description: >-
            The error log ID. You can provide the error ID when submitting a
            ticket to help Cobo to locate the issue.
          example: 0b6ddf19083c4bd1a9ca01bec44b24dd
    BaseEstimateStakingFee:
      type: object
      required:
        - activity_type
      properties:
        activity_type:
          $ref: '#/components/schemas/ActivityType'
    CreateStakeActivity:
      type: object
      required:
        - amount
        - fee
        - wallet_id
        - address
        - pool_id
      properties:
        request_id:
          type: string
          example: f47ac10b-58cc-4372-a567-0e02b2c3d479
          description: >-
            The request ID that is used to track a request. The request ID is
            provided by you and must be unique within your organization.
        source:
          $ref: '#/components/schemas/StakingSource'
        pool_id:
          $ref: '#/components/schemas/StakingPoolId'
        amount:
          type: string
          example: '100.00'
          description: The amount to stake.
        fee:
          $ref: '#/components/schemas/TransactionRequestFee'
        extra:
          oneOf:
            - $ref: '#/components/schemas/BabylonStakeExtra'
            - $ref: '#/components/schemas/EthStakeExtra'
            - $ref: '#/components/schemas/CoreStakeExtra'
          discriminator:
            propertyName: pool_type
            mapping:
              Babylon:
                $ref: '#/components/schemas/BabylonStakeExtra'
              ETHBeacon:
                $ref: '#/components/schemas/EthStakeExtra'
              CoreBTC:
                $ref: '#/components/schemas/CoreStakeExtra'
    CreateUnstakeActivity:
      type: object
      required:
        - staking_id
      properties:
        request_id:
          type: string
          example: f47ac10b-58cc-4372-a567-0e02b2c3d479
          description: >-
            The request ID that is used to track a request. The request ID is
            provided by you and must be unique within your organization.
        staking_id:
          type: string
          example: 0011039d-27fb-49ba-b172-6e0aa80e37ec
          description: The ID of the corresponding staking position.
        amount:
          type: string
          example: '100.00'
          description: >-
            The amount to unstake. For the Babylon protocol, this property is
            ignored.
        fee:
          $ref: '#/components/schemas/TransactionRequestFee'
        extra:
          description: >-
            Additional protocol-specific information required for the unstaking
            operation. The required fields vary depending on the staking
            protocol.
          oneOf:
            - $ref: '#/components/schemas/EthUnstakeExtra'
          discriminator:
            propertyName: pool_type
            mapping:
              ETHBeacon:
                $ref: '#/components/schemas/EthUnstakeExtra'
    CreateWithdrawActivity:
      type: object
      required:
        - staking_id
        - fee
      properties:
        request_id:
          type: string
          example: f47ac10b-58cc-4372-a567-0e02b2c3d479
          description: >-
            The request ID that is used to track a request. The request ID is
            provided by you and must be unique within your organization.
        staking_id:
          type: string
          example: 0011039d-27fb-49ba-b172-6e0aa80e37ec
          description: The ID of the corresponding staking position.
        amount:
          type: string
          example: '100.00'
          description: The amount to withdraw.
        fee:
          $ref: '#/components/schemas/TransactionRequestFee'
    TransactionRequestFee:
      oneOf:
        - $ref: '#/components/schemas/TransactionRequestFixedFee'
        - $ref: '#/components/schemas/TransactionRequestEvmEip1559Fee'
        - $ref: '#/components/schemas/TransactionRequestEvmLegacyFee'
        - $ref: '#/components/schemas/TransactionRequestUtxoFee'
        - $ref: '#/components/schemas/TransactionRequestSOLFee'
        - $ref: '#/components/schemas/TransactionRequestFILFee'
      discriminator:
        propertyName: fee_type
        mapping:
          Fixed:
            $ref: '#/components/schemas/TransactionRequestFixedFee'
          EVM_EIP_1559:
            $ref: '#/components/schemas/TransactionRequestEvmEip1559Fee'
          EVM_Legacy:
            $ref: '#/components/schemas/TransactionRequestEvmLegacyFee'
          UTXO:
            $ref: '#/components/schemas/TransactionRequestUtxoFee'
          SOL:
            $ref: '#/components/schemas/TransactionRequestSOLFee'
          FIL:
            $ref: '#/components/schemas/TransactionRequestFILFee'
    StakingPoolType:
      type: string
      enum:
        - Babylon
        - ETHBeacon
        - CoreBTC
        - SkyFarm
        - BitHive
        - BERABeacon
        - BeraChainBGT
      example: Babylon
      description: |
        The type of the staking pool. Possible values are:
        - `Babylon`: Babylon staking pool
        - `ETHBeacon`: Ethereum Beacon Chain staking pool
        - `CoreBTC`: Core BTC staking pool
        - `SkyFarm`: SKY farm staking pool
        - `BitHive`: BitHive staking pool
        - `BERABeacon`: BERA Beacon Chain staking pool
        - `BeraChainBGT`: Bera Chain BGT staking pool
    EstimatedFee:
      oneOf:
        - $ref: '#/components/schemas/EstimatedFixedFee'
        - $ref: '#/components/schemas/EstimatedEvmEip1559Fee'
        - $ref: '#/components/schemas/EstimatedEvmLegacyFee'
        - $ref: '#/components/schemas/EstimatedUtxoFee'
        - $ref: '#/components/schemas/EstimatedSOLFee'
        - $ref: '#/components/schemas/EstimatedFILFee'
      discriminator:
        propertyName: fee_type
        mapping:
          Fixed:
            $ref: '#/components/schemas/EstimatedFixedFee'
          EVM_EIP_1559:
            $ref: '#/components/schemas/EstimatedEvmEip1559Fee'
          EVM_Legacy:
            $ref: '#/components/schemas/EstimatedEvmLegacyFee'
          UTXO:
            $ref: '#/components/schemas/EstimatedUtxoFee'
          SOL:
            $ref: '#/components/schemas/EstimatedSOLFee'
          FIL:
            $ref: '#/components/schemas/EstimatedFILFee'
    ActivityType:
      type: string
      enum:
        - Stake
        - Unstake
        - Withdraw
        - Claim
      example: Stake
      description: >
        The type of the staking activity. Possible values include:

        - `Stake`: Stake tokens.

        - `Unstake`: Unstake tokens. Unstaked tokens are still in the staking
        protocol.

        - `Withdraw`: Withdraw tokens from the staking protocol to your wallet.

        - `Claim`: Claim rewards from the staking protocol.
    StakingSource:
      oneOf:
        - $ref: '#/components/schemas/MpcStakeSource'
      discriminator:
        propertyName: source_type
        mapping:
          Org-Controlled:
            $ref: '#/components/schemas/MpcStakeSource'
    StakingPoolId:
      type: string
      enum:
        - babylon_btc_signet
        - babylon_btc
        - beacon_eth
        - beacon_eth_holesky
        - core_btc
        - core_xtn
        - sky_farm_eth_usdc
        - bithive_signet
        - bithive
        - beacon_bera
        - beacon_bera_testnet
        - berachain_bgt
        - berachain_bgt_testnet
      example: babylon_btc_signet
      description: >-
        The ID of the staking pool. A staking pool is a pairing of a staking
        protocol and a specific type of token. Currently, `berachain_bgt` and
        `berachain_bgt_testnet` are not supported.
    BabylonStakeExtra:
      title: Babylon
      allOf:
        - $ref: '#/components/schemas/BaseStakeExtra'
        - type: object
          description: The staking information specific to the Babylon protocol.
          required:
            - finality_provider_public_key
            - stake_block_time
          properties:
            finality_provider_public_key:
              description: The public key of the finality provider.
              type: string
              pattern: ^[0-9a-fA-F]{64}$
              example: eca1b104dce16c30705f4147a9c4a373ac88646c5d1bcda6a89c018940cb96a0
            finality_provider_public_keys:
              description: >-
                The public keys of the finality providers, with each key
                corresponding to a BSN chain.
              type: array
              items:
                type: string
                pattern: ^[0-9a-fA-F]{64}$
                example: >-
                  eca1b104dce16c30705f4147a9c4a373ac88646c5d1bcda6a89c018940cb96a0
            stake_block_time:
              description: >-
                The number of blocks that need to be processed before the locked
                tokens are unlocked and become accessible.
              type: integer
              format: int64
              example: 2000
            auto_broadcast:
              description: >
                Whether to automatically broadcast the transaction. The default
                value is `true`.


                - `true`: Automatically broadcast the transaction.

                - `false`: The transaction will not be submitted to the
                blockchain automatically. You can call [Broadcast signed
                transactions](https://www.cobo.com/developers/v2/api-references/transactions/broadcast-signed-transactions)
                to broadcast the transaction to the blockchain, or retrieve the
                signed raw transaction data `raw_tx` by calling [Get transaction
                information](https://www.cobo.com/developers/v2/api-references/transactions/get-transaction-information)
                and broadcast it yourself.
              type: boolean
              example: false
            babylon_address:
              $ref: '#/components/schemas/StakingSource'
              description: The Babylon address to register for the staking.
            original_staking_id:
              description: >-
                The original staking ID to expand. Only set this when you want
                to expand existing staking.
              type: string
              example: 0011039d-27fb-49ba-b172-6e0aa80e37ec
    EthStakeExtra:
      title: Ethereum Beacon Chain
      allOf:
        - $ref: '#/components/schemas/BaseStakeExtra'
        - type: object
          description: The staking information specific to the Ethereum Beacon Chain.
          required:
            - provider_name
          properties:
            provider_name:
              description: The name of the provider.
              type: string
              example: Stakefish
    CoreStakeExtra:
      title: CORE
      allOf:
        - $ref: '#/components/schemas/BaseStakeExtra'
        - type: object
          description: The staking information specific to the CORE staking protocol.
          required:
            - timelock
            - validator_address
            - reward_address
          properties:
            timelock:
              description: >-
                The Unix timestamp (in seconds) when the staking position will
                be unlocked and available for withdrawal.
              type: integer
              example: 1704067200
            change_address:
              description: >-
                The change address on the Bitcoin chain. If not provided, the
                source wallet's address will be used as the change address.
              type: string
              example: bc1qxy2kgdygjrsqtzq2n0yrf2493p83kkfjhx0wlh
            validator_address:
              description: The validator's EVM address.
              type: string
              example: '0xd8dA6BF26964aF9D7eEd9e03E53415D37aA96045'
            reward_address:
              description: The EVM address to receive staking rewards.
              type: string
              example: '0xd8dA6BF26964aF9D7eEd9e03E53415D37aA96045'
    EthUnstakeExtra:
      title: Ethereum Beacon Chain
      allOf:
        - $ref: '#/components/schemas/BaseStakeExtra'
        - type: object
          description: >-
            Additional information required for unstaking from the Ethereum
            Beacon Chain.
          required:
            - validator_pubkeys
          properties:
            validator_pubkeys:
              description: >-
                A list of public keys identifying the validators to unstake from
                the Ethereum Beacon Chain.
              type: array
              items:
                type: string
              example:
                - '0x1234567890987654321012345678909876543210'
                - '0x1234567890987654321012345678909876543210'
    TransactionRequestFixedFee:
      type: object
      description: >
        The preset properties to limit transaction fee.


        In the fixed fee model, the transaction fee is a fixed amount within a
        certain amount of period regardless of the transaction size or network
        congestion, which can vary between different chains. For more
        information about the fixed fee model, refer to [Fee
        models](https://www.cobo.com/developers/v2/guides/transactions/estimate-fees#fee-models).


        You can specify the maximum fee amount to limit the transaction fee. The
        transaction will fail if the transaction fee exceeds the specified
        maximum fee amount.


        Switch between the tabs to display the properties for different
        transaction fee models.
      title: Fixed
      required:
        - fee_type
        - token_id
      allOf:
        - type: object
          properties:
            fee_type:
              $ref: '#/components/schemas/FeeType'
            token_id:
              type: string
              description: The token used to pay the transaction fee.
              example: TRON
        - $ref: '#/components/schemas/MaxFeeAmount'
    TransactionRequestEvmEip1559Fee:
      type: object
      description: >
        The preset properties to limit transaction fee.


        For more information about the EIP-1559 fee model, refer to [Fee
        models](https://www.cobo.com/developers/v2/guides/transactions/estimate-fees#fee-models).


        You can specify the maximum gas fee per gas unit, maximum priority fee
        per gas unit, and the gas limit to limit the gas price, priority fee per
        gas unit, gas units used in the transaction. 


        Switch between the tabs to display the properties for different
        transaction fee models.
      title: EVM_EIP_1559
      required:
        - fee_type
        - token_id
        - max_fee_per_gas
        - max_priority_fee_per_gas
      allOf:
        - type: object
          properties:
            fee_type:
              $ref: '#/components/schemas/FeeType'
            token_id:
              type: string
              description: The token used to pay the transaction fee.
              example: ETH
            gas_limit:
              type: string
              description: >-
                The gas limit. It represents the maximum number of gas units
                that you are willing to pay for the execution of a transaction
                or Ethereum Virtual Machine (EVM) operation. The gas unit cost
                of each operation varies.
              example: '21000'
        - $ref: '#/components/schemas/EvmEip1559FeeBasePrice'
    TransactionRequestEvmLegacyFee:
      type: object
      description: >
        The preset properties to limit transaction fee.


        For more information about the Legacy fee model, refer to [Fee
        models](https://www.cobo.com/developers/v2/guides/transactions/estimate-fees#fee-models).


        You can specify the gas limit to limit the gas units used in the
        transaction.


        Switch between the tabs to display the properties for different
        transaction fee models.
      required:
        - fee_type
        - token_id
        - gas_price
      title: EVM_Legacy
      allOf:
        - type: object
          properties:
            fee_type:
              $ref: '#/components/schemas/FeeType'
            token_id:
              type: string
              description: The token used to pay the transaction fee.
              example: ETH
            gas_limit:
              type: string
              description: >-
                The gas limit. It represents the maximum number of gas units
                that you are willing to pay for the execution of a transaction
                or Ethereum Virtual Machine (EVM) operation. The gas unit cost
                of each operation varies.
              example: '21000'
        - $ref: '#/components/schemas/EvmLegacyFeeBasePrice'
    TransactionRequestUtxoFee:
      type: object
      description: >
        The preset properties to limit transaction fee.


        For more information about the UTXO fee model, see [Fee
        models](https://www.cobo.com/developers/v2/guides/transactions/estimate-fees#fee-models).


        You can specify the maximum fee amount to limit the transaction fee. The
        transaction will fail if the transaction fee exceeds the specified
        maximum fee amount.


        Switch between the tabs to display the properties for different
        transaction fee models.
      required:
        - fee_type
        - token_id
      title: UTXO
      allOf:
        - type: object
          properties:
            fee_type:
              $ref: '#/components/schemas/FeeType'
            token_id:
              type: string
              description: The token used to pay the transaction fee.
              example: BTC
            max_fee_amount:
              type: string
              description: >-
                The maximum fee that you are willing to pay for the transaction.
                Provide the value without applying precision. The transaction
                will fail if the transaction fee exceeds the maximum fee.
              example: '0.1'
        - $ref: '#/components/schemas/UtxoFeeBasePrice'
    TransactionRequestSOLFee:
      type: object
      description: >
        The preset properties to limit transaction fee.


        For more information about the SOL fee model, see [Fee
        models](https://www.cobo.com/developers/v2/guides/transactions/estimate-fees#fee-models).


        You can specify CU price and CU limit to adjust the priority and
        resource allocation of your transaction.


        Switch between the tabs to display the properties for different
        transaction fee models.
      title: SOL
      required:
        - fee_type
        - token_id
        - compute_unit_price
        - compute_unit_limit
      allOf:
        - type: object
          properties:
            fee_type:
              $ref: '#/components/schemas/FeeType'
            token_id:
              type: string
              description: The token used to pay the transaction fee.
              example: ETH
        - $ref: '#/components/schemas/SOLComputeUnit'
    TransactionRequestFILFee:
      type: object
      description: >
        The preset properties to limit transaction fee.


        For more information about the FIL fee model, see [Fee
        models](https://www.cobo.com/developers/v2/guides/transactions/estimate-fees#fee-models).


        You can specify the gas fee cap, gas premium, and gas limit to control
        fee behavior and prioritization.


        Switch between the tabs to display the properties for different
        transaction fee models.
      title: FIL
      required:
        - fee_type
        - token_id
        - gas_fee_cap
        - gas_premium
      allOf:
        - type: object
          properties:
            fee_type:
              $ref: '#/components/schemas/FeeType'
            token_id:
              type: string
              description: The token used to pay the transaction fee.
              example: ETH
        - $ref: '#/components/schemas/FILPrice'
    EstimatedFixedFee:
      type: object
      description: >
        The estimated transaction fee based on the fixed fee model.


        For more details about the fixed fee model, see [Fee
        models](https://www.cobo.com/developers/v2/guides/transactions/estimate-fees#fee-models).
      title: Fixed
      required:
        - fee_type
        - token_id
        - fee_amount
      allOf:
        - type: object
          properties:
            fee_type:
              $ref: '#/components/schemas/FeeType'
            token_id:
              type: string
              description: The token used to pay the transaction fee.
              example: TRON
            is_loop:
              type: boolean
              description: >
                Whether the transaction was executed as a [Cobo
                Loop](https://manuals.cobo.com/en/portal/custodial-wallets/cobo-loop)
                transfer.

                - `true`: The transaction was executed as a Cobo Loop transfer.

                - `false`: The transaction was not executed as a Cobo Loop
                transfer.
              example: false
        - $ref: '#/components/schemas/FeeAmount'
    EstimatedEvmEip1559Fee:
      type: object
      description: >
        The estimated transaction fee based on the EIP-1559 fee model.


        For more details about the EIP-1559 fee model, see [Fee
        models](https://www.cobo.com/developers/v2/guides/transactions/estimate-fees#fee-models).
      title: EVM_EIP_1559
      required:
        - fee_type
        - token_id
        - recommended
      properties:
        fee_type:
          $ref: '#/components/schemas/FeeType'
        token_id:
          type: string
          description: The token used to pay the transaction fee.
          example: ETH
        slow:
          required:
            - max_fee_per_gas
            - max_priority_fee_per_gas
            - gas_limit
          allOf:
            - $ref: '#/components/schemas/EvmEip1559FeeBasePrice'
            - $ref: '#/components/schemas/FeeGasLimit'
            - $ref: '#/components/schemas/FeeReserved'
        recommended:
          required:
            - max_fee_per_gas
            - max_priority_fee_per_gas
            - gas_limit
          allOf:
            - $ref: '#/components/schemas/EvmEip1559FeeBasePrice'
            - $ref: '#/components/schemas/FeeGasLimit'
            - $ref: '#/components/schemas/FeeReserved'
        fast:
          required:
            - max_fee_per_gas
            - max_priority_fee_per_gas
            - gas_limit
          allOf:
            - $ref: '#/components/schemas/EvmEip1559FeeBasePrice'
            - $ref: '#/components/schemas/FeeGasLimit'
            - $ref: '#/components/schemas/FeeReserved'
    EstimatedEvmLegacyFee:
      type: object
      description: >
        The estimated transaction fee based on the Legacy fee model.


        For more details about the Legacy fee model, see [Fee
        models](https://www.cobo.com/developers/v2/guides/transactions/estimate-fees#fee-models).
      title: EVM_Legacy
      required:
        - fee_type
        - token_id
        - recommended
      properties:
        fee_type:
          $ref: '#/components/schemas/FeeType'
        token_id:
          type: string
          description: The token used to pay the transaction fee.
          example: ETH
        slow:
          required:
            - gas_price
            - gas_limit
          allOf:
            - $ref: '#/components/schemas/EvmLegacyFeeBasePrice'
            - $ref: '#/components/schemas/FeeGasLimit'
            - $ref: '#/components/schemas/FeeReserved'
        recommended:
          required:
            - gas_price
            - gas_limit
          allOf:
            - $ref: '#/components/schemas/EvmLegacyFeeBasePrice'
            - $ref: '#/components/schemas/FeeGasLimit'
            - $ref: '#/components/schemas/FeeReserved'
        fast:
          required:
            - gas_price
            - gas_limit
          allOf:
            - $ref: '#/components/schemas/EvmLegacyFeeBasePrice'
            - $ref: '#/components/schemas/FeeGasLimit'
            - $ref: '#/components/schemas/FeeReserved'
    EstimatedUtxoFee:
      type: object
      description: >
        The estimated transaction fee for UTXO-based chains.


        For more details about the UTXO fee model, see [Fee
        models](https://www.cobo.com/developers/v2/guides/transactions/estimate-fees#fee-models).
      title: UTXO
      required:
        - fee_type
        - token_id
        - recommended
      properties:
        fee_type:
          $ref: '#/components/schemas/FeeType'
        token_id:
          type: string
          description: The token used to pay the transaction fee.
          example: BTC
        slow:
          required:
            - fee_rate
            - fee_amount
          allOf:
            - $ref: '#/components/schemas/UtxoFeeBasePrice'
            - $ref: '#/components/schemas/FeeAmount'
        recommended:
          required:
            - fee_rate
            - fee_amount
          allOf:
            - $ref: '#/components/schemas/UtxoFeeBasePrice'
            - $ref: '#/components/schemas/FeeAmount'
        fast:
          required:
            - fee_rate
            - fee_amount
          allOf:
            - $ref: '#/components/schemas/UtxoFeeBasePrice'
            - $ref: '#/components/schemas/FeeAmount'
    EstimatedSOLFee:
      type: object
      description: >
        The estimated transaction fee based on the SOL fee model.


        For more details about the SOL fee model, see [Fee
        models](https://www.cobo.com/developers/v2/guides/transactions/estimate-fees#fee-models).
      title: SOL
      required:
        - fee_type
        - token_id
        - recommended
      properties:
        fee_type:
          $ref: '#/components/schemas/FeeType'
        token_id:
          type: string
          description: The token used to pay the transaction fee.
          example: ETH
        slow:
          required:
            - compute_unit_price
            - compute_unit_limit
            - base_fee
          allOf:
            - $ref: '#/components/schemas/SOLComputeUnit'
            - $ref: '#/components/schemas/SOLBase'
        recommended:
          required:
            - compute_unit_price
            - compute_unit_limit
            - base_fee
          allOf:
            - $ref: '#/components/schemas/SOLComputeUnit'
            - $ref: '#/components/schemas/SOLBase'
        fast:
          required:
            - compute_unit_price
            - compute_unit_limit
            - base_fee
          allOf:
            - $ref: '#/components/schemas/SOLComputeUnit'
            - $ref: '#/components/schemas/SOLBase'
    EstimatedFILFee:
      type: object
      description: >
        The estimated transaction fee based on the FIL fee model.


        For more details about the FIL fee model, see [Fee
        models](https://www.cobo.com/developers/v2/guides/transactions/estimate-fees#fee-models).
      title: FIL
      required:
        - fee_type
        - token_id
        - recommended
      properties:
        fee_type:
          $ref: '#/components/schemas/FeeType'
        token_id:
          type: string
          description: The token used to pay the transaction fee.
          example: ETH
        slow:
          required:
            - gas_premium
            - gas_fee_cap
            - gas_base
            - gas_limit
          allOf:
            - $ref: '#/components/schemas/FILPrice'
            - $ref: '#/components/schemas/FILBase'
        recommended:
          required:
            - gas_premium
            - gas_fee_cap
            - gas_base
            - gas_limit
          allOf:
            - $ref: '#/components/schemas/FILPrice'
            - $ref: '#/components/schemas/FILBase'
        fast:
          required:
            - gas_premium
            - gas_fee_cap
            - gas_base
            - gas_limit
          allOf:
            - $ref: '#/components/schemas/FILPrice'
            - $ref: '#/components/schemas/FILBase'
    MpcStakeSource:
      title: Stake from MPC Wallets
      allOf:
        - $ref: '#/components/schemas/BaseStakeSource'
    BaseStakeExtra:
      type: object
      description: The base information about a staking protocol.
      required:
        - pool_type
      properties:
        pool_type:
          $ref: '#/components/schemas/StakingPoolType'
    FeeType:
      type: string
      enum:
        - Fixed
        - EVM_EIP_1559
        - EVM_Legacy
        - UTXO
        - SOL
        - FIL
      example: EVM_EIP_1559
      default: EVM_EIP_1559
      description: >
        The fee model. Possible values include:

        - `Fixed`: The fixed fee model. 

        - `EVM_EIP_1559`: The EIP-1559 fee model.

        - `EVM_Legacy`: The legacy fee model.

        - `UTXO`: The fee model used in UTXO-based blockchains, such as Bitcoin.

        - `SOL`: The fee model used in Solana.

        - `FIL`: The fee model used in Filecoin.



        Each fee model requires a different set of properties. Switch between
        the above tabs for details.


        To learn more about the fee models, refer to [Fee
        models](https://www.cobo.com/developers/v2/guides/transactions/estimate-fees#fee-models).
    MaxFeeAmount:
      type: object
      properties:
        max_fee_amount:
          type: string
          description: >-
            The maximum fee that you are willing to pay for the transaction.
            Provide the value without applying precision. The transaction will
            fail if the transaction fee exceeds the maximum fee.
          example: '0.1'
    EvmEip1559FeeBasePrice:
      type: object
      properties:
        max_fee_per_gas:
          type: string
          description: The maximum gas fee per gas unit used on the chain, in wei.
          example: '9000000000000'
        max_priority_fee_per_gas:
          type: string
          description: >-
            The maximum priority fee per gas unit used, in wei. The maximum
            priority fee represents the highest amount of miner tips that you
            are willing to pay for your transaction.
          example: '1000000000000'
    EvmLegacyFeeBasePrice:
      type: object
      properties:
        gas_price:
          type: string
          description: >-
            The gas price, in wei. The gas price represents the amount of ETH
            that must be paid to validators for processing transactions per gas
            unit used.
          example: '100000000'
    UtxoFeeBasePrice:
      type: object
      properties:
        fee_rate:
          type: string
          description: >-
            The fee rate in sat/vByte. The fee rate represents the satoshis you
            are willing to pay for each byte of data that your transaction will
            consume on the blockchain.
          example: '50'
    SOLComputeUnit:
      type: object
      properties:
        compute_unit_price:
          type: string
          description: >-
            The price paid per compute unit. This value determines the priority
            fee for the transaction, allowing you to increase inclusion
            probability in congested conditions.
          example: '0.0001'
        compute_unit_limit:
          type: string
          description: >-
            The maximum number of compute units your transaction is allowed to
            consume. It sets an upper bound on computational resource usage to
            prevent overload.
          example: '200000'
    FILPrice:
      type: object
      properties:
        gas_premium:
          type: string
          description: >-
            An optional tip you can include to prioritize your transaction. The
            gas premium incentivizes miners to include your transaction sooner
            than those offering only the base fee.
          example: '0.0001'
        gas_fee_cap:
          type: string
          description: The maximum gas price you are willing to pay per unit of gas.
          example: '0.00035'
        gas_limit:
          type: string
          description: The maximum amount of gas your transaction is allowed to consume.
          example: '500'
    FeeAmount:
      type: object
      description: The transaction fee.
      properties:
        fee_amount:
          type: string
          description: The transaction fee that you need to pay for the transaction.
          example: '0.1'
    FeeGasLimit:
      type: object
      properties:
        gas_limit:
          type: string
          description: >-
            The gas limit. It represents the maximum number of gas units that
            you are willing to pay for the execution of a transaction or
            Ethereum Virtual Machine (EVM) operation. The gas unit cost of each
            operation varies.
          example: '21000'
    FeeReserved:
      type: object
      properties:
        reserved_fee:
          type: string
          description: >-
            The estimated fee required for submitting the transaction data to L1
            (Layer 1), measured in wei.
          example: '1000000000000'
    SOLBase:
      type: object
      properties:
        base_fee:
          type: string
          description: >-
            A fixed fee charged per signature. The default is 5,000 lamports per
            signature.
          example: '0.000005'
        rent_amount:
          type: string
          description: >-
            The rent fee charged by the network to store non–rent-exempt
            accounts on-chain. It is deducted periodically until the account
            maintains the minimum balance required for rent exemption.
          example: '0.00001 '
    FILBase:
      type: object
      properties:
        gas_base:
          type: string
          description: >-
            The minimum fee required for a transaction to be included in a
            block. The base fee is dynamically adjusted based on network
            congestion to maintain target block utilization. It is burned rather
            than paid to miners, reducing the total Filecoin supply over time.
          example: '0.0002'
    BaseStakeSource:
      type: object
      description: The information about the staking source.
      required:
        - source_type
        - wallet_id
        - address
      properties:
        source_type:
          $ref: '#/components/schemas/StakeSourceType'
        wallet_id:
          type: string
          format: uuid
          example: f47ac10b-58cc-4372-a567-0e02b2c3d479
          description: The wallet ID.
        address:
          type: string
          description: The wallet address.
          example: '0xd8dA6BF26964aF9D7eEd9e03E53415D37aA96045'
    StakeSourceType:
      type: string
      enum:
        - Org-Controlled
      example: Org-Controlled
      description: |
        The staking source type. Possible values include:
          - `Org-Controlled`: An MPC Wallet (Organization-Controlled Wallet).
  securitySchemes:
    CoboAuth:
      type: apiKey
      in: header
      name: BIZ-API-KEY
      description: >
        The API key. For more details, refer to [API
        key](https://www.cobo.com/developers/v2/guides/overview/cobo-auth#api-key).


        In the API playground, enter your [API
        secret](https://www.cobo.com/developers/v2/guides/overview/cobo-auth#api-secret),
        and your API key will be accordingly calculated.
    OAuth2:
      type: oauth2
      description: >-
        The [Org Access
        Token](https://www.cobo.com/developers/v2/apps/org-access-tokens). Use
        this authorization method only if you are developing Cobo Portal Apps
        for installation and use across different organizations.
      flows:
        authorizationCode:
          authorizationUrl: https://auth.cobo.com/authorize
          tokenUrl: https://auth.cobo.com/oauth/token
          scopes:
            address_book.read: Read address book
            api_key.read: Read API key information
            callback.read: Read callback message
            callback.resend: Resend callback message
            wallet.create: Create wallet
            wallet.read: Read wallet information
            wallet.update: Update wallet information
            wallet.delete: Delete wallet information
            wallet.create_address: Create wallet address
            wallet.manage_utxo: Manage UTXO
            mpc_project.create: Create MPC project
            mpc_project.read: Read MPC project information
            mpc_project.update: Update MPC project information
            mpc_vault.create: Create MPC Vault
            mpc_vault.read: Read MPC Vault information
            mpc_vault.update: Update MPC Vault information
            mpc_key_group.create: Create MPC key group
            mpc_key_group.read: Read MPC key group information
            mpc_key_group.update: Update MPC key group information
            mpc_key_group.delete: Delete MPC key group information
            transaction.read: Read transaction information
            transaction.withdraw: Make withdrawals
            transaction.estimate_fee: Estimate transaction fee
            transaction.contract_call: Initiate contract calls
            transaction.message_sign: Initiate message signings
            transaction.stake: Stake assets
            transaction.unstake: Unstake assets
            transaction.unstake_withdraw: Withdraw unstaked assets
            transaction.manage: Manage ongoing transactions
            transaction.update: Update transaction notes
            travel_rule.read: Read travel rule information
            travel_rule.edit: Edit travel rule information
            webhook.read: Read webhook URLs/events
            webhook.edit: Edit webhook URLs
            webhook.resend: Resend webhook events
            payment_orders_payin.create: Create pay-in order
            payment_orders_payin.read: Read pay-in order information
            payment_orders_payin.update: Update pay-in order
            payment_orders_refund.create: Create payment refund order
            payment_orders_refund.read: Read payment refund order information
            payment_settlement.create: Create payment settlement request
            payment_settlement.read: Read payment settlement request information
            payment_merchant.create: Create payment merchant
            payment_merchant.read: Read payment merchant information
            payment_merchant.update: Update payment merchant
            payment_forced_sweep.create: Create payment force sweep request
            payment_forced_sweep.read: Read payment force sweep request information
            compliance_funds.refund: Refund compliance funds request
            compliance_funds.isolate: Isolate compliance funds request
            compliance_funds.unfreeze: Unfreeze compliance funds request
            compliance_funds.read: Read compliance funds request information
            compliance_kyt_review.update: Update KYT review status
            compliance_kyt_decisions.update: Update KYT decision status
            compliance_kyt_status.read: Read KYT screening status
            compliance_kya_screenings.create: Create KYA address screening requests
            compliance_kya_screenings.read: Read KYA address screening results

````